<!DOCTYPE html>
<html lang="en" data-mode="dark">
  <head prefix="og: http://ogp.me/ns#">
    <meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="generator" content="Hugo 0.68.3">
<meta name="theme" content="Color Your World -- gitlab.com/rmaguiar/hugo-theme-color-your-world">
























<title>Syntax Highlighting Test | QEMU QED</title>


<meta name="author" content="Ethan Gates">
<meta name="description" content="A page full of code samples.">


<meta name="robots" content="index follow">
<meta name="referrer" content="no-referrer-when-downgrade">




  
    <link rel="canonical" href="https://example.com/usage/syntax-highlighting-test/">
  








<meta property="og:site_name" content="QEMU QED">
<meta property="og:title" content="Syntax Highlighting Test">
<meta property="og:description" content="A page full of code samples.">
  <meta property="og:url" content="https://example.com/usage/syntax-highlighting-test/">








  <meta property="og:type" content="article">
  
  

  
  
  
    <meta name="twitter:creator" content="@@the_bfool">
  
  

  <meta name="twitter:site" content="@@the_bfool">







  <meta name="twitter:dnt" content="on">












<meta name="theme-color" content="#222">

<meta name="apple-mobile-web-app-capable" content="yes">
<meta name="apple-mobile-web-app-status-bar-style" content="default">










  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  







  <script type="application/ld+json">
    {
      "@context": "https://schema.org",
      "@type": "Article",
      "mainEntityOfPage": {
        "@type": "WebSite",
        "@id": "https:\/\/example.com\/"
      },
      "headline": "Syntax Highlighting Test",
      "description": "A page full of code samples.",
      
      "url": "https:\/\/example.com\/usage\/syntax-highlighting-test\/",
      "inLanguage": "en",
      "datePublished": "0001-01-01",
      
      "wordCount" : "1245",
      "publisher": {
        "@type": "Person",
        "name": "Ethan Gates"
      },
      "author": {
        "@type": "Person",
        "name": "Ethan Gates",
        "description": "User Support Lead for the EaaSI program of work",
        "sameAs": ["https://github.com/EG-tech","https://gitlab.com/EG-tech","https://twitter.com/@the_bfool"]
      }
    }
  </script>






<link rel="stylesheet" href="/css/main.min.css">



<noscript>

  
  

  

    
      <meta name="theme-color" content="#dd587c">
    

  

  <style>
  
    html {
      --accent: #dd587c;
    }
  
    .req-js {
      display: none;
    }
    
  </style>
  
</noscript>






  <link rel="preload" href="/fonts/open-sans-v17-latin-700.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-700.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-italic.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-italic.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-regular.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-regular.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/oswald-v29-latin-700.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/oswald-v29-latin-700.woff2" as="font" crossorigin="anonymous">













  <link rel="me" href="https://github.com/EG-tech"> 

  <link rel="me" href="https://gitlab.com/EG-tech"> 

  <link rel="me" href="https://twitter.com/@the_bfool"> 







  <script>
    
      'use strict';

// Get default accent colors



// Get CSS transition


// =================================================
// Mode switcher + Custom accent color
// Based on: https://gist.github.com/regpaq/04c67e8aceecbf0fd819945835412d1f
// =================================================



const ROOT = document.documentElement;

const SHEET = document.documentElement.style;
const META_THEME_COLOR = document.querySelector('meta[name=theme-color]');

// Set the dark
function setDark() {
  ROOT.dataset.mode = 'dark'
};

// Set the light
function setLight() {
  ROOT.dataset.mode = 'light'
};

// Initialization triggers light/dark mode based on prior preference, then OS setting
// And yes, I know 'true' here is a string
if(localStorage.getItem('isDark') == 'true') {
  setDark()
} else if(localStorage.getItem('isDark') == 'false') {
  setLight()

  

};




// TODO
// Maybe I should rethink this ...
function getAccent() {
  if (ROOT.dataset.mode === 'dark') {
  
    if (localStorage.getItem('darkAccent') === null) {
      
      
      
      var currentAccent = "#dd587c"
    } else {
    
      var currentAccent = localStorage.getItem('darkAccent')
      
      
      
    }
  } else if (ROOT.dataset.mode === 'light') {

    if (localStorage.getItem('lightAccent') === null) {
  
      
      

      var currentAccent = "#225670"
    } else {
      var currentAccent = localStorage.getItem('lightAccent')
      
      
      
    }
  };
  
  return currentAccent
};

var activeAccent = getAccent();

// Set the active accent color for these right after setting mode color
// Should mitigate any flickering
SHEET.setProperty('--accent', activeAccent);

// Also meta-theme cuz, why not
META_THEME_COLOR.setAttribute('content', activeAccent);


function updateAccent() {
  var activeAccent = getAccent();

  SHEET.setProperty('--accent', activeAccent);
  PALETTE.value = activeAccent;
  META_THEME_COLOR.setAttribute('content', activeAccent);
};


document.addEventListener('DOMContentLoaded', function () {

  // Update the color picker with the active accent color 
  PALETTE.value = activeAccent;

  // Smooth transition, only when changing modes (and not loading pages)
  function smoothTransition() {
    document.body.style.transition 
    = document.querySelector('header').style.transition
    = document.querySelector('footer').style.transition
    = 'background-color .3s ease, color .3s ease'
  };
  
  // Give the user a choice
  function userModeChange() {
  
    smoothTransition();

    if (ROOT.dataset.mode == 'light') {
      setDark();
      localStorage.setItem('isDark', 'true')

      
      
    } else {
      setLight();
      localStorage.setItem('isDark', 'false')
      
      
      
    };
    
    updateAccent()
  };

  
  // TEST
  // Keyboard shortcut for mode change, here for testing purposes only
  // CTRL + ALT + M
  


  
  
  // Mode change button
  document.querySelector('footer button')
    .addEventListener('click', userModeChange)
})

    
  </script>



  </head>

  <body>

    <header>
      

  <a href="/">QEMU QED</a>




  
    <nav aria-label="Main menu.">
      <ul>
        
          <li>
            <a class="btn" href="/installing/">Installing QEMU</a>
          </li>
        
          <li>
            <a class="btn" href="/usage/">Using QEMU</a>
          </li>
        
          <li>
            <a class="btn" href="/recipes/">Recipes</a>
          </li>
        
          <li>
            <a class="btn" href="/glossary/">Glossary</a>
          </li>
        
          <li>
            <a class="btn" href="/resources/">More Resources</a>
          </li>
        
          <li>
            <a class="btn" href="/contact/">Contact</a>
          </li>
        
      </ul>
    </nav>
  


    </header>

    <div class="filler">
      

  <main>
    <article>
      <header>
        
        <h1>Syntax Highlighting Test</h1>

        
          <section class="terms">
            <ul><li><a class="btn" href="/tags/extra/">extra</a></li><li><a class="btn" href="/tags/syntax-highlighting/">syntax highlighting</a></li></ul>
          </section>
        
        
        
      </header>
    
      
  <details class="toc" open>
    <summary class="outline-dashed">
      Contents
    </summary>
    
    <nav id="TableOfContents">
  <ul>
    <li><a href="#bash">Bash</a></li>
    <li><a href="#c">C</a></li>
    <li><a href="#css">CSS</a></li>
    <li><a href="#go">Go</a></li>
    <li><a href="#haskell">Haskell</a></li>
    <li><a href="#html">HTML</a></li>
    <li><a href="#java">Java</a></li>
    <li><a href="#javascript">JavaScript</a></li>
    <li><a href="#json">JSON</a></li>
    <li><a href="#objective-c">Objective-C</a></li>
    <li><a href="#perl">Perl</a></li>
    <li><a href="#php">PHP</a></li>
    <li><a href="#python">Python</a></li>
    <li><a href="#ruby">Ruby</a></li>
    <li><a href="#scss">SCSS</a></li>
    <li><a href="#sql">SQL</a></li>
    <li><a href="#xml">XML</a></li>
  </ul>
</nav>
  </details>

      







































  




<h2 id="bash">Bash</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-bash" data-lang="bash"><span class="cp">#!/bin/bash
</span><span class="cp"></span>
<span class="nb">cd</span> <span class="nv">$ROOT_DIR</span>
<span class="nv">DOT_FILES</span><span class="o">=</span><span class="s2">&#34;lastpass weechat ssh Xauthority&#34;</span>

<span class="k">for</span> dotfile in <span class="nv">$DOT_FILES</span><span class="p">;</span> <span class="k">do</span> conform_link <span class="s2">&#34;</span><span class="nv">$DATA_DIR</span><span class="s2">/</span><span class="nv">$dotfile</span><span class="s2">&#34;</span> <span class="s2">&#34;.</span><span class="nv">$dotfile</span><span class="s2">&#34;</span><span class="p">;</span> <span class="k">done</span>

<span class="c1"># TODO: refactor with suffix variables (or common cron values)</span>

<span class="k">case</span> <span class="s2">&#34;</span><span class="nv">$PLATFORM</span><span class="s2">&#34;</span> in
    linux<span class="o">)</span>
        <span class="c1">#conform_link &#34;$CONF_DIR/shell/zshenv&#34; &#34;.zshenv&#34;</span>
        crontab -l &gt; <span class="nv">$ROOT_DIR</span>/tmp/crontab-conflict-arch
        <span class="nb">cd</span> <span class="nv">$ROOT_DIR</span>/<span class="nv">$CONF_DIR</span>/cron
        <span class="k">if</span> <span class="o">[[</span> <span class="s2">&#34;</span><span class="k">$(</span>diff ~/tmp/crontab-conflict-arch crontab-current-arch<span class="k">)</span><span class="s2">&#34;</span> <span class="o">==</span> <span class="s2">&#34;&#34;</span>
            <span class="o">]]</span><span class="p">;</span>
            <span class="k">then</span> <span class="c1"># no difference with current backup</span>
                logger <span class="s2">&#34;</span><span class="nv">$LOG_PREFIX</span><span class="s2">: crontab live settings match stored &#34;</span><span class="se">\
</span><span class="se"></span>                    <span class="s2">&#34;settings; no restore required&#34;</span>
                rm ~/tmp/crontab-conflict-arch
            <span class="k">else</span> <span class="c1"># current crontab settings in file do not match live settings</span>
                crontab <span class="nv">$ROOT_DIR</span>/<span class="nv">$CONF_DIR</span>/cron/crontab-current-arch
                logger <span class="s2">&#34;</span><span class="nv">$LOG_PREFIX</span><span class="s2">: crontab stored settings conflict with &#34;</span><span class="se">\
</span><span class="se"></span>                    <span class="s2">&#34;live settings; stored settings restored. &#34;</span><span class="se">\
</span><span class="se"></span>                    <span class="s2">&#34;Previous settings recorded in ~/tmp/crontab-conflict-arch.&#34;</span>
        <span class="k">fi</span>
    <span class="p">;;</span>
</code></pre></div><h2 id="c">C</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-c" data-lang="c"><span class="cp">#define UNICODE
</span><span class="cp">#include</span> <span class="cpf">&lt;windows.h&gt;</span><span class="cp">
</span><span class="cp"></span>
<span class="kt">int</span> <span class="nf">main</span><span class="p">(</span><span class="kt">int</span> <span class="n">argc</span><span class="p">,</span> <span class="kt">char</span> <span class="o">**</span><span class="n">argv</span><span class="p">)</span> <span class="p">{</span>
  <span class="kt">int</span> <span class="n">speed</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="n">speed1</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="n">speed2</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="c1">// 1-20
</span><span class="c1"></span>  <span class="n">printf</span><span class="p">(</span><span class="s">&#34;Set Mouse Speed by Maverick</span><span class="se">\n</span><span class="s">&#34;</span><span class="p">);</span>

  <span class="n">SystemParametersInfo</span><span class="p">(</span><span class="n">SPI_GETMOUSESPEED</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">speed</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
  <span class="n">printf</span><span class="p">(</span><span class="s">&#34;Current speed: %2d</span><span class="se">\n</span><span class="s">&#34;</span><span class="p">,</span> <span class="n">speed</span><span class="p">);</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">argc</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span> <span class="k">return</span> <span class="mi">0</span><span class="p">;</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">argc</span> <span class="o">&gt;=</span> <span class="mi">2</span><span class="p">)</span> <span class="n">sscanf</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="s">&#34;%d&#34;</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">speed1</span><span class="p">);</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">argc</span> <span class="o">&gt;=</span> <span class="mi">3</span><span class="p">)</span> <span class="n">sscanf</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span> <span class="s">&#34;%d&#34;</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">speed2</span><span class="p">);</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">argc</span> <span class="o">==</span> <span class="mi">2</span><span class="p">)</span> <span class="c1">// set speed to first value
</span><span class="c1"></span>    <span class="n">speed</span> <span class="o">=</span> <span class="n">speed1</span><span class="p">;</span>
  <span class="k">else</span> <span class="k">if</span> <span class="p">(</span><span class="n">speed</span> <span class="o">==</span> <span class="n">speed1</span> <span class="o">||</span> <span class="n">speed</span> <span class="o">==</span> <span class="n">speed2</span><span class="p">)</span> <span class="c1">// alternate
</span><span class="c1"></span>    <span class="n">speed</span> <span class="o">=</span> <span class="n">speed1</span> <span class="o">+</span> <span class="n">speed2</span> <span class="o">-</span> <span class="n">speed</span><span class="p">;</span>
  <span class="k">else</span>
    <span class="n">speed</span> <span class="o">=</span> <span class="n">speed1</span><span class="p">;</span>  <span class="c1">// start with first value
</span><span class="c1"></span>
  <span class="n">SystemParametersInfo</span><span class="p">(</span><span class="n">SPI_SETMOUSESPEED</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span>  <span class="n">speed</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
  <span class="n">SystemParametersInfo</span><span class="p">(</span><span class="n">SPI_GETMOUSESPEED</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">speed</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
  <span class="n">printf</span><span class="p">(</span><span class="s">&#34;New speed:     %2d</span><span class="se">\n</span><span class="s">&#34;</span><span class="p">,</span> <span class="n">speed</span><span class="p">);</span>
  <span class="k">return</span> <span class="mi">0</span><span class="p">;</span>
<span class="p">}</span>
</code></pre></div><h2 id="css">CSS</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-css" data-lang="css"><span class="c">/* CSS Comment */</span>
<span class="p">#</span><span class="nn">some-id</span> <span class="p">.</span><span class="nc">some-class</span> <span class="p">{</span>
  <span class="k">float</span><span class="p">:</span> <span class="kc">left</span><span class="p">;</span>
  <span class="k">width</span><span class="p">:</span> <span class="mi">100</span><span class="kt">px</span><span class="p">;</span>
<span class="p">}</span>
</code></pre></div><h2 id="go">Go</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-go" data-lang="go"><span class="kn">package</span> <span class="nx">main</span>
<span class="kn">import</span> <span class="s">&#34;fmt&#34;</span>
<span class="kd">func</span> <span class="nf">main</span><span class="p">()</span> <span class="p">{</span>
    <span class="nx">fmt</span><span class="p">.</span><span class="nf">Println</span><span class="p">(</span><span class="s">&#34;Hello, 世界&#34;</span><span class="p">)</span>
<span class="p">}</span>
</code></pre></div><h2 id="haskell">Haskell</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-haskell" data-lang="haskell"><span class="cm">{-# LANGUAGE OverloadedStrings #-}</span>
<span class="kr">module</span> <span class="nn">Main</span> <span class="kr">where</span>

<span class="c1">--import Prelude hiding (id)</span>
<span class="c1">--import Control.Category (id)</span>
<span class="kr">import</span> <span class="nn">Control.Arrow</span> <span class="p">((</span><span class="o">&gt;&gt;&gt;</span><span class="p">),</span> <span class="p">(</span><span class="o">***</span><span class="p">),</span> <span class="nf">arr</span><span class="p">)</span>
<span class="kr">import</span> <span class="nn">Control.Monad</span> <span class="p">(</span><span class="nf">forM_</span><span class="p">)</span>
<span class="c1">-- import Data.Monoid (mempty, mconcat)</span>
<span class="c1">-- import System.FilePath</span>

<span class="kr">import</span> <span class="nn">Hakyll</span>

<span class="nf">main</span> <span class="ow">::</span> <span class="kt">IO</span> <span class="nb">()</span>
<span class="nf">main</span> <span class="ow">=</span> <span class="n">hakyll</span> <span class="o">$</span> <span class="kr">do</span>

    <span class="n">route</span>   <span class="s">&#34;css/*&#34;</span> <span class="o">$</span> <span class="n">setExtension</span> <span class="s">&#34;css&#34;</span>
    <span class="n">compile</span> <span class="s">&#34;css/*&#34;</span> <span class="o">$</span> <span class="n">byExtension</span> <span class="p">(</span><span class="ne">error</span> <span class="s">&#34;Not a (S)CSS file&#34;</span><span class="p">)</span>
        <span class="p">[</span> <span class="p">(</span><span class="s">&#34;.css&#34;</span><span class="p">,</span>  <span class="n">compressCssCompiler</span><span class="p">)</span>
        <span class="p">,</span> <span class="p">(</span><span class="s">&#34;.scss&#34;</span><span class="p">,</span> <span class="n">sass</span><span class="p">)</span>
        <span class="p">]</span>

    <span class="n">route</span>   <span class="s">&#34;js/**&#34;</span> <span class="n">idRoute</span>
    <span class="n">compile</span> <span class="s">&#34;js/**&#34;</span> <span class="n">copyFileCompiler</span>

    <span class="n">route</span>   <span class="s">&#34;img/*&#34;</span> <span class="n">idRoute</span>
    <span class="n">compile</span> <span class="s">&#34;img/*&#34;</span> <span class="n">copyFileCompiler</span>

    <span class="n">compile</span> <span class="s">&#34;templates/*&#34;</span> <span class="n">templateCompiler</span>

    <span class="n">forM_</span> <span class="p">[</span><span class="s">&#34;test.md&#34;</span><span class="p">,</span> <span class="s">&#34;index.md&#34;</span><span class="p">]</span> <span class="o">$</span> <span class="nf">\</span><span class="n">page</span> <span class="ow">-&gt;</span> <span class="kr">do</span>
        <span class="n">route</span>   <span class="n">page</span> <span class="o">$</span> <span class="n">setExtension</span> <span class="s">&#34;html&#34;</span>
        <span class="n">compile</span> <span class="n">page</span> <span class="o">$</span> <span class="n">pageCompiler</span>
            <span class="o">&gt;&gt;&gt;</span> <span class="n">applyTemplateCompiler</span> <span class="s">&#34;templates/default.html&#34;</span>
            <span class="o">&gt;&gt;&gt;</span> <span class="n">relativizeUrlsCompiler</span>

<span class="nf">sass</span> <span class="ow">::</span> <span class="kt">Compiler</span> <span class="kt">Resource</span> <span class="kt">String</span>
<span class="nf">sass</span> <span class="ow">=</span> <span class="n">getResourceString</span> <span class="o">&gt;&gt;&gt;</span> <span class="n">unixFilter</span> <span class="s">&#34;sass&#34;</span> <span class="p">[</span><span class="s">&#34;-s&#34;</span><span class="p">,</span> <span class="s">&#34;--scss&#34;</span><span class="p">]</span>
                         <span class="o">&gt;&gt;&gt;</span> <span class="n">arr</span> <span class="n">compressCss</span>
</code></pre></div><h2 id="html">HTML</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-html" data-lang="html"><span class="cp">&lt;!DOCTYPE html PUBLIC &#34;-//W3C//DTD HTML 4.01 Transitional//EN&#34;&gt;</span>
<span class="p">&lt;</span><span class="nt">html</span><span class="p">&gt;</span>
  <span class="p">&lt;</span><span class="nt">head</span><span class="p">&gt;</span>
    <span class="p">&lt;</span><span class="nt">title</span><span class="p">&gt;</span>A Tiny Page<span class="p">&lt;/</span><span class="nt">title</span><span class="p">&gt;</span>
    <span class="c">&lt;!-- Valid HTML Comment --&gt;</span>
    <span class="p">&lt;</span><span class="nt">style</span> <span class="na">type</span><span class="o">=</span><span class="s">&#34;text/css&#34;</span><span class="p">&gt;</span>
    <span class="o">&lt;!</span><span class="nt">--</span> <span class="nt">Invalid</span> <span class="nt">HTML</span> <span class="nt">Comment</span> <span class="nt">--</span><span class="o">&gt;</span>
      <span class="c">/* Inline CSS Comment */</span>
      <span class="nt">p</span> <span class="p">{</span>
        <span class="k">font-size</span><span class="p">:</span> <span class="mi">15</span><span class="kt">pt</span><span class="p">;</span>
        <span class="k">color</span><span class="p">:</span> <span class="mh">#000</span><span class="p">;</span>
        <span class="k">float</span><span class="p">:</span> <span class="kc">right</span><span class="p">;</span>
      <span class="p">}</span>
    <span class="p">&lt;/</span><span class="nt">style</span><span class="p">&gt;</span>
  <span class="p">&lt;/</span><span class="nt">head</span><span class="p">&gt;</span>
  <span class="p">&lt;</span><span class="nt">body</span> <span class="na">bgcolor</span><span class="o">=</span><span class="s">&#34;#FFFFFF&#34;</span> <span class="na">text</span><span class="o">=</span><span class="s">&#34;#000000&#34;</span> <span class="na">link</span><span class="o">=</span><span class="s">&#34;#0000CC&#34;</span><span class="p">&gt;</span>
    <span class="p">&lt;</span><span class="nt">h1</span><span class="p">&gt;</span>Heading 1<span class="p">&lt;/</span><span class="nt">h1</span><span class="p">&gt;</span>
    <span class="p">&lt;</span><span class="nt">h2</span><span class="p">&gt;</span>Heading 2<span class="p">&lt;/</span><span class="nt">h2</span><span class="p">&gt;</span>
    <span class="p">&lt;</span><span class="nt">p</span><span class="p">&gt;</span>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.<span class="p">&lt;/</span><span class="nt">p</span><span class="p">&gt;</span>
    <span class="c">&lt;!--  Valid HTML Comment --&gt;</span>
    <span class="p">&lt;</span><span class="nt">script</span> <span class="na">language</span><span class="o">=</span><span class="s">&#34;javascript&#34;</span> <span class="na">type</span><span class="o">=</span><span class="s">&#34;text/javascript&#34;</span><span class="p">&gt;</span>
      <span class="kd">function</span> <span class="nx">changeHeight</span><span class="p">(</span><span class="nx">h</span><span class="p">)</span> <span class="p">{</span>
        <span class="kd">var</span> <span class="nx">tds</span> <span class="o">=</span> <span class="nb">document</span><span class="p">.</span><span class="nx">getElementsByTagName</span><span class="p">(</span><span class="s2">&#34;td&#34;</span><span class="p">);</span>
        <span class="k">for</span><span class="p">(</span><span class="kd">var</span> <span class="nx">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="nx">i</span> <span class="o">&lt;</span> <span class="nx">tds</span><span class="p">.</span><span class="nx">length</span><span class="p">;</span> <span class="nx">i</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
          <span class="nx">tds</span><span class="p">[</span><span class="nx">i</span><span class="p">].</span><span class="nx">setAttribute</span><span class="p">(</span><span class="s2">&#34;height&#34;</span><span class="p">,</span> <span class="nx">h</span> <span class="o">+</span> <span class="s2">&#34;px&#34;</span><span class="p">);</span>
      <span class="p">}}</span>
    <span class="p">&lt;/</span><span class="nt">script</span><span class="p">&gt;</span>
  <span class="p">&lt;/</span><span class="nt">body</span><span class="p">&gt;</span>
<span class="p">&lt;/</span><span class="nt">html</span><span class="p">&gt;</span>
</code></pre></div><h2 id="java">Java</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-java" data-lang="java"><span class="kn">import</span> <span class="nn">java.util.Map</span><span class="o">;</span>
<span class="kn">import</span> <span class="nn">java.util.TreeSet</span><span class="o">;</span>

<span class="kd">public</span> <span class="kd">class</span> <span class="nc">GetEnv</span> <span class="o">{</span>
  <span class="cm">/**
</span><span class="cm">   * let&#39;s test generics
</span><span class="cm">   * @param args the command line arguments
</span><span class="cm">   */</span>
  <span class="kd">public</span> <span class="kd">static</span> <span class="kt">void</span> <span class="nf">main</span><span class="o">(</span><span class="n">String</span><span class="o">[]</span> <span class="n">args</span><span class="o">)</span> <span class="o">{</span>
    <span class="c1">// get a map of environment variables
</span><span class="c1"></span>    <span class="n">Map</span><span class="o">&lt;</span><span class="n">String</span><span class="o">,</span> <span class="n">String</span><span class="o">&gt;</span> <span class="n">env</span> <span class="o">=</span> <span class="n">System</span><span class="o">.</span><span class="na">getenv</span><span class="o">();</span>
    <span class="c1">// build a sorted set out of the keys and iterate
</span><span class="c1"></span>    <span class="k">for</span><span class="o">(</span><span class="n">String</span> <span class="n">k</span><span class="o">:</span> <span class="k">new</span> <span class="n">TreeSet</span><span class="o">&lt;</span><span class="n">String</span><span class="o">&gt;(</span><span class="n">env</span><span class="o">.</span><span class="na">keySet</span><span class="o">()))</span> <span class="o">{</span>
      <span class="n">System</span><span class="o">.</span><span class="na">out</span><span class="o">.</span><span class="na">printf</span><span class="o">(</span><span class="s">&#34;%s = %s\n&#34;</span><span class="o">,</span> <span class="n">k</span><span class="o">,</span> <span class="n">env</span><span class="o">.</span><span class="na">get</span><span class="o">(</span><span class="n">k</span><span class="o">));</span>
    <span class="o">}</span>
  <span class="o">}</span>    
<span class="o">}</span>
</code></pre></div><h2 id="javascript">JavaScript</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-javascript" data-lang="javascript"><span class="c1">// Inline Comment
</span><span class="c1"></span><span class="kd">var</span> <span class="kc">undefined</span><span class="p">,</span>
    <span class="nx">xui</span><span class="p">,</span>
    <span class="nb">window</span>     <span class="o">=</span> <span class="k">this</span><span class="p">,</span>
    <span class="nx">string</span>     <span class="o">=</span> <span class="k">new</span> <span class="nb">String</span><span class="p">(</span><span class="s1">&#39;string&#39;</span><span class="p">),</span>
    <span class="nb">document</span>   <span class="o">=</span> <span class="nb">window</span><span class="p">.</span><span class="nb">document</span><span class="p">,</span>
    <span class="nx">simpleExpr</span> <span class="o">=</span> <span class="sr">/^#?([\w-]+)$/</span><span class="p">;</span>

<span class="cm">/** 
</span><span class="cm"> * Block Comment
</span><span class="cm"> */</span> 
<span class="kd">function</span> <span class="nx">changeHeight</span> <span class="p">(</span><span class="nx">h</span><span class="p">)</span> <span class="p">{</span>
  <span class="kd">var</span> <span class="nx">tds</span> <span class="o">=</span> <span class="nb">document</span><span class="p">.</span><span class="nx">getElementsByTagName</span><span class="p">(</span><span class="s2">&#34;td&#34;</span><span class="p">);</span>

  <span class="k">for</span> <span class="p">(</span><span class="kd">var</span> <span class="nx">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="nx">i</span> <span class="o">&lt;</span> <span class="nx">tds</span><span class="p">.</span><span class="nx">length</span><span class="p">;</span> <span class="nx">i</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
    <span class="nx">tds</span><span class="p">[</span><span class="nx">i</span><span class="p">].</span><span class="nx">setAttribute</span><span class="p">(</span><span class="s2">&#34;height&#34;</span><span class="p">,</span> <span class="nx">h</span> <span class="o">+</span> <span class="s2">&#34;px&#34;</span><span class="p">);</span>
  <span class="p">}</span>
<span class="p">}</span>
</code></pre></div><h2 id="json">JSON</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-json" data-lang="json"><span class="p">{</span>
  <span class="nt">&#34;employees&#34;</span><span class="p">:</span> <span class="p">[{</span>
    <span class="nt">&#34;firstName&#34;</span><span class="p">:</span> <span class="s2">&#34;John&#34;</span><span class="p">,</span> 
    <span class="nt">&#34;lastName&#34;</span><span class="p">:</span> <span class="s2">&#34;Doe&#34;</span>
  <span class="p">}]</span>
<span class="p">}</span>
</code></pre></div><h2 id="objective-c">Objective-C</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-objective-c" data-lang="objective-c"><span class="cp">#import &#34;Cocoa1AppDelegate.h&#34;
</span><span class="cp"></span>
<span class="k">@implementation</span> <span class="nc">Cocoa1AppDelegate</span>

<span class="k">@synthesize</span> <span class="n">window</span><span class="p">,</span><span class="n">siteUrl</span><span class="p">,</span><span class="n">pageContents</span><span class="p">;</span>

<span class="p">-</span> <span class="p">(</span><span class="kt">void</span><span class="p">)</span><span class="nf">applicationDidFinishLaunching:</span><span class="p">(</span><span class="n">NSNotification</span> <span class="o">*</span><span class="p">)</span><span class="nv">aNotification</span> <span class="p">{</span>
    <span class="c1">// Insert code here to initialize your application
</span><span class="c1"></span>    <span class="n">model</span> <span class="o">=</span> <span class="p">[[</span><span class="n">Cocoa1Model</span> <span class="n">alloc</span><span class="p">]</span> <span class="n">init</span><span class="p">];</span>
<span class="p">}</span>

<span class="p">-</span> <span class="p">(</span><span class="kt">IBAction</span><span class="p">)</span><span class="nf">getSiteContents:</span><span class="p">(</span><span class="kt">id</span><span class="p">)</span><span class="nv">sender</span> <span class="p">{</span>
    <span class="p">[</span><span class="n">model</span> <span class="nl">setPageUrl</span><span class="p">:[</span><span class="n">siteUrl</span> <span class="n">stringValue</span><span class="p">]];</span>
    <span class="n">NSString</span><span class="o">*</span> <span class="n">reply</span> <span class="o">=</span> <span class="p">[</span><span class="n">model</span> <span class="n">getUrlAsString</span><span class="p">];</span>
    <span class="n">NSLog</span><span class="p">(</span><span class="s">@&#34;pageSrc: %@&#34;</span><span class="p">,</span> <span class="n">reply</span><span class="p">);</span>
    <span class="p">[</span><span class="n">pageContents</span> <span class="nl">setString</span><span class="p">:</span><span class="n">reply</span><span class="p">];</span>
    <span class="p">[[[</span><span class="n">pageContents</span> <span class="n">textStorage</span><span class="p">]</span> <span class="n">mutableString</span><span class="p">]</span> <span class="nl">appendString</span><span class="p">:</span><span class="n">reply</span><span class="p">];</span>
<span class="p">}</span>

<span class="k">@end</span>
</code></pre></div><h2 id="perl">Perl</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-perl" data-lang="perl"><span class="ch">#!perl -w</span>

<span class="c1"># Time-stamp: &lt;2002/04/06, 13:12:13 (EST), maverick, csvformat.pl&gt;</span>
<span class="c1"># Two pass CSV file to table formatter</span>

<span class="nv">$delim</span> <span class="o">=</span> <span class="nv">$#ARGV</span> <span class="o">&gt;=</span> <span class="mi">1</span> <span class="p">?</span> <span class="nv">$ARGV</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="p">:</span> <span class="s">&#39;,&#39;</span><span class="p">;</span>
<span class="k">print</span> <span class="bp">STDERR</span> <span class="s">&#34;Split pattern: $delim\n&#34;</span><span class="p">;</span>

<span class="c1"># first pass</span>
<span class="nb">open</span> <span class="n">F</span><span class="p">,</span> <span class="s">&#34;&lt;$ARGV[0]&#34;</span> <span class="ow">or</span> <span class="nb">die</span><span class="p">;</span>
<span class="k">while</span><span class="p">(</span><span class="sr">&lt;F&gt;</span><span class="p">)</span>
<span class="p">{</span>
  <span class="nb">chomp</span><span class="p">;</span>
  <span class="nv">$i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span>
  <span class="nb">map</span> <span class="p">{</span> <span class="nv">$max</span><span class="p">[</span><span class="nv">$_</span><span class="o">-&gt;</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span> <span class="o">=</span> <span class="nv">$_</span><span class="o">-&gt;</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">if</span> <span class="nv">$_</span><span class="o">-&gt;</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&gt;</span> <span class="p">(</span><span class="nv">$max</span><span class="p">[</span><span class="nv">$_</span><span class="o">-&gt;</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span> <span class="o">||</span> <span class="mi">0</span><span class="p">)</span> <span class="p">}</span>
    <span class="p">(</span><span class="nb">map</span> <span class="p">{[</span><span class="nb">length</span> <span class="nv">$_</span><span class="p">,</span> <span class="nv">$i</span><span class="o">++</span><span class="p">]}</span> <span class="nb">split</span><span class="p">(</span><span class="nv">$delim</span><span class="p">));</span>
<span class="p">}</span>
<span class="nb">close</span> <span class="n">F</span><span class="p">;</span>

<span class="k">print</span> <span class="bp">STDERR</span> <span class="s">&#39;Field width:   &#39;</span><span class="p">,</span> <span class="nb">join</span><span class="p">(</span><span class="s">&#39;, &#39;</span><span class="p">,</span> <span class="nv">@max</span><span class="p">),</span> <span class="s">&#34;\n&#34;</span><span class="p">;</span>
<span class="k">print</span> <span class="bp">STDERR</span> <span class="nb">join</span><span class="p">(</span><span class="s">&#39; &#39;</span><span class="p">,</span> <span class="nb">map</span> <span class="p">{</span><span class="s">&#39;-&#39;</span> <span class="n">x</span> <span class="nv">$_</span><span class="p">}</span> <span class="nv">@max</span><span class="p">);</span>

<span class="c1"># second pass</span>
<span class="nb">open</span> <span class="n">F</span><span class="p">,</span> <span class="s">&#34;&lt;$ARGV[0]&#34;</span> <span class="ow">or</span> <span class="nb">die</span><span class="p">;</span>
<span class="k">while</span><span class="p">(</span><span class="sr">&lt;F&gt;</span><span class="p">)</span>
<span class="p">{</span>
  <span class="nb">chomp</span><span class="p">;</span>
  <span class="nv">$i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span>
  <span class="nb">map</span> <span class="p">{</span> <span class="nb">printf</span><span class="p">(</span><span class="s">&#34;%-$max[$_-&gt;[1]]s &#34;</span><span class="p">,</span> <span class="nv">$_</span><span class="o">-&gt;</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="p">}</span>
    <span class="p">(</span><span class="nb">map</span> <span class="p">{[</span><span class="nv">$_</span><span class="p">,</span> <span class="nv">$i</span><span class="o">++</span><span class="p">]}</span> <span class="nb">split</span><span class="p">(</span><span class="nv">$delim</span><span class="p">));</span>
  <span class="k">print</span> <span class="s">&#34;\n&#34;</span><span class="p">;</span>
<span class="p">}</span>
<span class="nb">close</span> <span class="n">F</span><span class="p">;</span>
</code></pre></div><h2 id="php">PHP</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-php" data-lang="php"><span class="cp">&lt;?php</span>

<span class="k">require_once</span><span class="p">(</span><span class="nv">$GLOBALS</span><span class="p">[</span><span class="s1">&#39;g_campsiteDir&#39;</span><span class="p">]</span><span class="o">.</span> <span class="s2">&#34;/</span><span class="si">$ADMIN_DIR</span><span class="s2">/country/common.php&#34;</span><span class="p">);</span>
<span class="k">require_once</span><span class="p">(</span><span class="nv">$GLOBALS</span><span class="p">[</span><span class="s1">&#39;g_campsiteDir&#39;</span><span class="p">]</span><span class="o">.</span> <span class="s2">&#34;/classes/SimplePager.php&#34;</span><span class="p">);</span>

<span class="nx">camp_load_translation_strings</span><span class="p">(</span><span class="s2">&#34;api&#34;</span><span class="p">);</span>

<span class="nv">$f_country_language_selected</span> <span class="o">=</span> <span class="nx">camp_session_get</span><span class="p">(</span><span class="s1">&#39;f_language_selected&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">);</span>
<span class="nv">$f_country_offset</span> <span class="o">=</span> <span class="nx">camp_session_get</span><span class="p">(</span><span class="s1">&#39;f_country_offset&#39;</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>

<span class="k">if</span> <span class="p">(</span><span class="k">empty</span><span class="p">(</span><span class="nv">$f_country_language_selected</span><span class="p">))</span> <span class="p">{</span>
    <span class="nv">$f_country_language_selected</span> <span class="o">=</span> <span class="k">null</span><span class="p">;</span>
<span class="p">}</span>

<span class="nv">$ItemsPerPage</span> <span class="o">=</span> <span class="mi">20</span><span class="p">;</span>
<span class="nv">$languages</span> <span class="o">=</span> <span class="nx">Language</span><span class="o">::</span><span class="na">GetLanguages</span><span class="p">(</span><span class="k">null</span><span class="p">,</span> <span class="k">null</span><span class="p">,</span> <span class="k">null</span><span class="p">,</span> <span class="k">array</span><span class="p">(),</span> <span class="k">array</span><span class="p">(),</span> <span class="k">true</span><span class="p">);</span>
<span class="nv">$numCountries</span> <span class="o">=</span> <span class="nx">Country</span><span class="o">::</span><span class="na">GetNumCountries</span><span class="p">(</span><span class="nv">$f_country_language_selected</span><span class="p">);</span>

<span class="nv">$pager</span> <span class="o">=</span> <span class="k">new</span> <span class="nx">SimplePager</span><span class="p">(</span><span class="nv">$numCountries</span><span class="p">,</span> <span class="nv">$ItemsPerPage</span><span class="p">,</span> <span class="s2">&#34;index.php?&#34;</span><span class="p">);</span>

<span class="nv">$crumbs</span> <span class="o">=</span> <span class="k">array</span><span class="p">();</span>
<span class="nv">$crumbs</span><span class="p">[]</span> <span class="o">=</span> <span class="k">array</span><span class="p">(</span><span class="nx">getGS</span><span class="p">(</span><span class="s2">&#34;Configure&#34;</span><span class="p">),</span> <span class="s2">&#34;&#34;</span><span class="p">);</span>
<span class="nv">$crumbs</span><span class="p">[]</span> <span class="o">=</span> <span class="k">array</span><span class="p">(</span><span class="nx">getGS</span><span class="p">(</span><span class="s2">&#34;Countries&#34;</span><span class="p">),</span> <span class="s2">&#34;&#34;</span><span class="p">);</span>

<span class="k">echo</span> <span class="nx">camp_html_breadcrumbs</span><span class="p">(</span><span class="nv">$crumbs</span><span class="p">);</span>

<span class="cp">?&gt;</span>

<span class="cp">&lt;?php</span> <span class="k">if</span> <span class="p">(</span><span class="nv">$g_user</span><span class="o">-&gt;</span><span class="na">hasPermission</span><span class="p">(</span><span class="s2">&#34;ManageCountries&#34;</span><span class="p">))</span> <span class="p">{</span> <span class="cp">?&gt;</span>
<span class="p">&lt;</span><span class="nt">table</span> <span class="na">BORDER</span><span class="o">=</span><span class="s">&#34;0&#34;</span> <span class="na">CELLSPACING</span><span class="o">=</span><span class="s">&#34;0&#34;</span> <span class="na">CELLPADDING</span><span class="o">=</span><span class="s">&#34;1&#34;</span><span class="p">&gt;</span>
    <span class="p">&lt;</span><span class="nt">tr</span><span class="p">&gt;</span>
        <span class="p">&lt;</span><span class="nt">td</span><span class="p">&gt;&lt;</span><span class="nt">a</span> <span class="na">href</span><span class="o">=</span><span class="s">&#34;add.php&#34;</span><span class="p">&gt;</span><span class="cp">&lt;?php</span> <span class="nx">putGS</span><span class="p">(</span><span class="s2">&#34;Add new&#34;</span><span class="p">);</span> <span class="cp">?&gt;</span><span class="p">&lt;/</span><span class="nt">a</span><span class="p">&gt;&lt;/</span><span class="nt">td</span><span class="p">&gt;</span>
    <span class="p">&lt;/</span><span class="nt">tr</span><span class="p">&gt;</span>
<span class="p">&lt;/</span><span class="nt">table</span><span class="p">&gt;</span>
<span class="cp">&lt;?php</span> <span class="p">}</span> <span class="cp">?&gt;</span>
</code></pre></div><h2 id="python">Python</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-python" data-lang="python"><span class="c1"># Inline Python Comment</span>
<span class="k">class</span> <span class="nc">ExitNotifyThread</span><span class="p">(</span><span class="n">Thread</span><span class="p">):</span>
    <span class="s2">&#34;&#34;&#34;
</span><span class="s2">    Block-Level Python Comment
</span><span class="s2">    &#34;&#34;&#34;</span>
    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">global</span> <span class="n">exitthreads</span><span class="p">,</span> <span class="n">profiledir</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">threadid</span> <span class="o">=</span> <span class="n">thread</span><span class="o">.</span><span class="n">get_ident</span><span class="p">()</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">profiledir</span><span class="p">:</span> <span class="c1"># normal case</span>
                <span class="n">Thread</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="kn">import</span> <span class="nn">cProfile</span> <span class="kn">as</span> <span class="nn">profile</span>
                <span class="k">except</span> <span class="ne">ImportError</span><span class="p">:</span>
                    <span class="kn">import</span> <span class="nn">profile</span>
                <span class="n">prof</span> <span class="o">=</span> <span class="n">profile</span><span class="o">.</span><span class="n">Profile</span><span class="p">()</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">prof</span> <span class="o">=</span> <span class="n">prof</span><span class="o">.</span><span class="n">runctx</span><span class="p">(</span><span class="s2">&#34;Thread.run(self)&#34;</span><span class="p">,</span> <span class="nb">globals</span><span class="p">(),</span> <span class="nb">locals</span><span class="p">())</span>
                <span class="k">except</span> <span class="ne">SystemExit</span><span class="p">:</span>
                    <span class="k">pass</span>
                <span class="n">prof</span><span class="o">.</span><span class="n">dump_stats</span><span class="p">(</span> \
                            <span class="n">profiledir</span> <span class="o">+</span> <span class="s2">&#34;/&#34;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">threadid</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&#34;_&#34;</span> <span class="o">+</span> \
                            <span class="bp">self</span><span class="o">.</span><span class="n">getName</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&#34;.prof&#34;</span><span class="p">)</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">setExitCause</span><span class="p">(</span><span class="s1">&#39;EXCEPTION&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">sys</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">setExitException</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">()[</span><span class="mi">1</span><span class="p">])</span>
                <span class="n">tb</span> <span class="o">=</span> <span class="n">traceback</span><span class="o">.</span><span class="n">format_exc</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">setExitStackTrace</span><span class="p">(</span><span class="n">tb</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">setExitCause</span><span class="p">(</span><span class="s1">&#39;NORMAL&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;exitmessage&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">setExitMessage</span><span class="p">(</span><span class="bp">None</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">exitthreads</span><span class="p">:</span>
            <span class="n">exitthreads</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="bp">True</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">setExitCause</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cause</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">exitcause</span> <span class="o">=</span> <span class="n">cause</span>
    <span class="k">def</span> <span class="nf">getExitCause</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="s2">&#34;&#34;&#34;Returns the cause of the exit, one of:
</span><span class="s2">        &#39;EXCEPTION&#39; -- the thread aborted because of an exception
</span><span class="s2">        &#39;NORMAL&#39; -- normal termination.&#34;&#34;&#34;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">exitcause</span>
    <span class="k">def</span> <span class="nf">setExitException</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">exc</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">exitexception</span> <span class="o">=</span> <span class="n">exc</span>
    <span class="k">def</span> <span class="nf">getExitException</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="s2">&#34;&#34;&#34;If getExitCause() is &#39;EXCEPTION&#39;, holds the value from
</span><span class="s2">        sys.exc_info()[1] for this exception.&#34;&#34;&#34;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">exitexception</span>
    <span class="k">def</span> <span class="nf">setExitStackTrace</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">st</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">exitstacktrace</span> <span class="o">=</span> <span class="n">st</span>
    <span class="k">def</span> <span class="nf">getExitStackTrace</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="s2">&#34;&#34;&#34;If getExitCause() is &#39;EXCEPTION&#39;, returns a string representing
</span><span class="s2">        the stack trace for this exception.&#34;&#34;&#34;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">exitstacktrace</span>
    <span class="k">def</span> <span class="nf">setExitMessage</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="s2">&#34;&#34;&#34;Sets the exit message to be fetched by a subsequent call to
</span><span class="s2">        getExitMessage.  This message may be any object or type except
</span><span class="s2">        None.&#34;&#34;&#34;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">exitmessage</span> <span class="o">=</span> <span class="n">msg</span>
    <span class="k">def</span> <span class="nf">getExitMessage</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="s2">&#34;&#34;&#34;For any exit cause, returns the message previously set by
</span><span class="s2">        a call to setExitMessage(), or None if there was no such message
</span><span class="s2">        set.&#34;&#34;&#34;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">exitmessage</span>
</code></pre></div><h2 id="ruby">Ruby</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-ruby" data-lang="ruby"><span class="n">desc</span> <span class="s2">&#34;Edit a post (defaults to most recent)&#34;</span>
<span class="n">task</span> <span class="ss">:edit_post</span><span class="p">,</span> <span class="ss">:title</span> <span class="k">do</span> <span class="o">|</span><span class="n">t</span><span class="p">,</span> <span class="n">args</span><span class="o">|</span>
  <span class="n">args</span><span class="o">.</span><span class="n">with_defaults</span><span class="p">(</span><span class="ss">:title</span> <span class="o">=&gt;</span> <span class="kp">false</span><span class="p">)</span>
  <span class="n">posts</span> <span class="o">=</span> <span class="no">Dir</span><span class="o">.</span><span class="n">glob</span><span class="p">(</span><span class="s2">&#34;</span><span class="si">#{</span><span class="n">source_dir</span><span class="si">}</span><span class="s2">/</span><span class="si">#{</span><span class="n">posts_dir</span><span class="si">}</span><span class="s2">/*.*&#34;</span><span class="p">)</span>
  <span class="n">post</span> <span class="o">=</span> <span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">title</span><span class="p">)</span> <span class="p">?</span> <span class="n">post</span> <span class="o">=</span> <span class="n">posts</span><span class="o">.</span><span class="n">keep_if</span> <span class="p">{</span><span class="o">|</span><span class="n">post</span><span class="o">|</span> <span class="n">post</span> <span class="o">=~</span> <span class="sr">/</span><span class="si">#{</span><span class="n">args</span><span class="o">.</span><span class="n">title</span><span class="si">}</span><span class="sr">/</span><span class="p">}</span><span class="o">.</span><span class="n">last</span> <span class="p">:</span> <span class="n">posts</span><span class="o">.</span><span class="n">last</span>
  <span class="k">if</span> <span class="n">post</span>
    <span class="nb">puts</span> <span class="s2">&#34;Opening </span><span class="si">#{</span><span class="n">post</span><span class="si">}</span><span class="s2"> with </span><span class="si">#{</span><span class="n">editor</span><span class="si">}</span><span class="s2">...&#34;</span>
    <span class="nb">system</span> <span class="s2">&#34;</span><span class="si">#{</span><span class="no">ENV</span><span class="o">[</span><span class="s1">&#39;EDITOR&#39;</span><span class="o">]</span><span class="si">}</span><span class="s2"> </span><span class="si">#{</span><span class="n">post</span><span class="si">}</span><span class="s2"> &amp;&#34;</span>
  <span class="k">else</span>
    <span class="nb">puts</span> <span class="s2">&#34;No posts were found with </span><span class="se">\&#34;</span><span class="si">#{</span><span class="n">args</span><span class="o">.</span><span class="n">title</span><span class="si">}</span><span class="se">\&#34;</span><span class="s2"> in the title.&#34;</span>
  <span class="k">end</span>
<span class="k">end</span>
</code></pre></div><h2 id="scss">SCSS</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-scss" data-lang="scss"><span class="k">@import</span> <span class="s2">&#34;grids&#34;</span><span class="p">;</span>

<span class="nv">$blue</span><span class="o">:</span> <span class="ni">blue</span><span class="p">;</span>

<span class="nt">a</span><span class="nc">.myAnchor</span> <span class="p">{</span>
    <span class="nt">color</span><span class="nd">:</span> <span class="err">$</span><span class="nt">blue</span><span class="p">;</span>
    <span class="k">&amp;</span><span class="nd">:hover</span> <span class="p">{</span>
        <span class="nt">text-decoration</span><span class="nd">:</span> <span class="nt">underline</span><span class="p">;</span>
    <span class="p">}</span>
    <span class="k">&amp;</span><span class="nd">:visited</span> <span class="p">{</span>
        <span class="nt">color</span><span class="nd">:</span> <span class="nt">purple</span><span class="p">;</span>
    <span class="p">}</span>
<span class="p">}</span>

<span class="nc">.error-input</span> <span class="p">{</span>
  <span class="k">@extend</span> <span class="nc">.input</span><span class="p">;</span>
  <span class="nt">border</span><span class="nd">:</span> <span class="nt">4px</span> <span class="nt">solid</span> <span class="nn">#e74c3c</span><span class="p">;</span>
<span class="p">}</span>

<span class="err">%</span><span class="nt">input-style</span> <span class="p">{</span>
    <span class="nt">font-size</span><span class="nd">:</span> <span class="nt">14px</span><span class="p">;</span>
<span class="p">}</span>

<span class="nt">input</span> <span class="p">{</span>
    <span class="k">@extend</span> <span class="err">%</span><span class="nt">input-style</span><span class="p">;</span>
    <span class="nt">color</span><span class="nd">:</span> <span class="nt">black</span><span class="p">;</span>
<span class="p">}</span>

<span class="k">@mixin</span><span class="nf"> media</span><span class="p">(</span><span class="nv">$queryString</span><span class="p">){</span>
    <span class="k">@media</span> <span class="si">#{</span><span class="nv">$queryString</span><span class="si">}</span> <span class="p">{</span>
      <span class="k">@content</span><span class="p">;</span>
    <span class="p">}</span>
<span class="p">}</span>

<span class="k">@function</span> <span class="nt">getColumnWidth</span><span class="o">(</span><span class="err">$</span><span class="nt">width</span><span class="o">,</span> <span class="err">$</span><span class="nt">columns</span><span class="o">,</span><span class="err">$</span><span class="nt">margin</span><span class="o">)</span><span class="p">{</span>
    <span class="k">@return</span> <span class="o">(</span><span class="err">$</span><span class="nt">width</span> <span class="o">/</span> <span class="err">$</span><span class="nt">columns</span><span class="o">)</span> <span class="nt">-</span> <span class="o">(</span><span class="err">$</span><span class="nt">margin</span> <span class="o">*</span> <span class="nt">2</span><span class="o">)</span><span class="p">;</span>
<span class="p">}</span>

<span class="nv">$settings</span><span class="o">:</span> <span class="p">(</span>
    <span class="n">maxWidth</span><span class="o">:</span> <span class="mi">800</span><span class="kt">px</span><span class="o">,</span>
    <span class="no">columns</span><span class="o">:</span> <span class="mi">12</span><span class="o">,</span>
    <span class="no">margin</span><span class="o">:</span> <span class="mi">15</span><span class="kt">px</span><span class="o">,</span>
    <span class="n">breakpoints</span><span class="o">:</span> <span class="p">(</span>
        <span class="n">xs</span><span class="o">:</span> <span class="s2">&#34;(max-width : 480px)&#34;</span><span class="o">,</span>
        <span class="n">sm</span><span class="o">:</span> <span class="s2">&#34;(max-width : 768px) and (min-width: 481px)&#34;</span><span class="o">,</span>
        <span class="n">md</span><span class="o">:</span> <span class="s2">&#34;(max-width : 1024px)  and (min-width: 769px)&#34;</span><span class="o">,</span>
        <span class="n">lg</span><span class="o">:</span> <span class="s2">&#34;(min-width : 1025px)&#34;</span>
    <span class="p">)</span>
<span class="p">);</span>
</code></pre></div><h2 id="sql">SQL</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="k">column_name</span><span class="p">,</span> <span class="k">column_name</span> <span class="k">FROM</span> <span class="k">table_name</span><span class="p">;</span>
</code></pre></div><h2 id="xml">XML</h2>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-xml" data-lang="xml"><span class="nt">&lt;employees&gt;</span>
    <span class="nt">&lt;employee&gt;</span>
        <span class="nt">&lt;firstName&gt;</span>John<span class="nt">&lt;/firstName&gt;</span> <span class="nt">&lt;lastName&gt;</span>Doe<span class="nt">&lt;/lastName&gt;</span>
    <span class="nt">&lt;/employee&gt;</span>
<span class="nt">&lt;/employees&gt;</span>
</code></pre></div><hr>
<p>Source:
<a href="https://gist.github.com/cbracco/32036db5425d23de70c3dd9a846517d0">markdown-pygments-syntax-highlighting-test.md · GitHub</a></p>



    </article>
  </main>


    </div>
    
    <footer>
      

  
    <p>Copyright © EaaSI <a href="https://gitlab.com/eaasi/qemu-qed">GitLab</a> Contributers;
Site built using <a href="https://gohugo.io/">Hugo</a> and the <a href="https://gitlab.com/rmaguiar/hugo-theme-color-your-world">Color Your World</a> theme by Raphael Aguiar</p>
  













<section class="req-js">
  <button class="outline-dashed" title="Change to light/dark mode."><svg xmlns="http://www.w3.org/2000/svg" aria-hidden="true"><use xlink:href="#adjust"/></svg></button><input class="outline-dashed" type="color" list="presets" value="#dd587c" title="Change accent color." aria-label="Change accent color."><datalist id="presets"><option value="#225670"><option value="#dd587c"><option value="#1f676b"><option value="#f3a530"><option value="#902b37"><option value="#1dbc91"><option value="#754e85"><option value="#7fc121"><option value="#a8314a"><option value="#ff7433"><option value="#3e6728"><option value="#c063bd"></datalist>
</section>



  <noscript>
    <p class="noscript">Unable to execute JavaScript. Some features were disabled.</p>
  </noscript>



    </footer>
    
    <svg xmlns="http://www.w3.org/2000/svg" width="0" height="0" aria-hidden="true">
      <symbol viewBox="0 0 512 512" id="adjust">
        <path d="M8 256c0 136.966 111.033 248 248 248s248-111.034 248-248S392.966 8 256 8 8 119.033 8 256zm248 184V72c101.705 0 184 82.311 184 184 0 101.705-82.311 184-184 184z"/>
      </symbol>
      
      
      
      
  
<symbol viewBox="0 0 448 512" id="hashtag">
  <path d="M440.667 182.109l7.143-40c1.313-7.355-4.342-14.109-11.813-14.109h-74.81l14.623-81.891C377.123 38.754 371.468 32 363.997 32h-40.632a12 12 0 0 0-11.813 9.891L296.175 128H197.54l14.623-81.891C213.477 38.754 207.822 32 200.35 32h-40.632a12 12 0 0 0-11.813 9.891L132.528 128H53.432a12 12 0 0 0-11.813 9.891l-7.143 40C33.163 185.246 38.818 192 46.289 192h74.81L98.242 320H19.146a12 12 0 0 0-11.813 9.891l-7.143 40C-1.123 377.246 4.532 384 12.003 384h74.81L72.19 465.891C70.877 473.246 76.532 480 84.003 480h40.632a12 12 0 0 0 11.813-9.891L151.826 384h98.634l-14.623 81.891C234.523 473.246 240.178 480 247.65 480h40.632a12 12 0 0 0 11.813-9.891L315.472 384h79.096a12 12 0 0 0 11.813-9.891l7.143-40c1.313-7.355-4.342-14.109-11.813-14.109h-74.81l22.857-128h79.096a12 12 0 0 0 11.813-9.891zM261.889 320h-98.634l22.857-128h98.634l-22.857 128z"/>
</symbol>


  <symbol viewBox="0 0 320 512" id="caret-down">
    <path d="M31.3 192h257.3c17.8 0 26.7 21.5 14.1 34.1L174.1 354.8c-7.8 7.8-20.5 7.8-28.3 0L17.2 226.1C4.6 213.5 13.5 192 31.3 192z"/>
  </symbol>


      
      
      
    </svg>

    
    
    

      <script>
        
          'use strict';const PALETTE=document.querySelector('footer input');PALETTE.onchange=function(){const PICK=PALETTE.value;SHEET.setProperty('--accent',PICK);if(ROOT.dataset.mode==='light'){localStorage.setItem('lightAccent',PICK)}else{localStorage.setItem('darkAccent',PICK)};updateAccent()};
        
      </script>

    
    
    
    

  </body>
</html>
